=== modified file 'src/com/goldencode/p2j/ui/client/gui/BrowseGuiImpl.java'
--- src/com/goldencode/p2j/ui/client/gui/BrowseGuiImpl.java	2022-03-07 13:06:46 +0000
+++ src/com/goldencode/p2j/ui/client/gui/BrowseGuiImpl.java	2022-03-10 10:33:31 +0000
@@ -203,6 +203,9 @@
 **     VVT 20220218 Missing @Override annotations added and other cosmetic fixes.
 **     HC  20220304 OFF-END is triggered for additional events: arrow down, pg down, mouse wheel,
 **                  scroll.
+**     VVT 20220307 findMouseSource(w.findMouseSource(eventID, NativePoint)) overridden to assure the mouse
+**                  pressed and mouse release events are sent to the same widget. See #6013-152. Also
+**                  multiple cosmetic fixes.
 */
 
 /*
@@ -262,7 +265,6 @@
 
 import java.awt.event.*;
 import java.util.*;
-import java.util.logging.*;
 
 import com.goldencode.p2j.ui.*;
 import com.goldencode.p2j.ui.chui.*;
@@ -367,9 +369,6 @@
    /** Template of a sorting number image name. */
    private static final String SORT_NUMBER_IMAGE_NAME_TEMPLATE = "sort-num-%d";
 
-   /** Logger. */
-   private static final Logger LOG = LogHelper.getLogger(BrowseGuiImpl.class);
-
    /**
     * When the current row is out of the view below, then if we press UP key, the new current row
     * becomes <code>max(1, DOWN - UP_KEY_BOTTOM_OFFSET_ROWS)</code>th row in the viewport
@@ -909,7 +908,7 @@
     *
     * @return attribute container for the given cell.
     */
-   public GuiCellAttributes getCellAttr(BrowseRow[] rowCache, int viewportIndex, int columnOrdinal)
+   public static GuiCellAttributes getCellAttr(BrowseRow[] rowCache, int viewportIndex, int columnOrdinal)
    {
       if (rowCache == null || viewportIndex >= rowCache.length)
       {
@@ -1338,7 +1337,7 @@
    @Override
    public void drawCaret()
    {
-
+      // no-op
    }
 
    /**
@@ -1586,6 +1585,7 @@
       // row resize messages first
       if (id == Keyboard.SE_START_ROW_RESIZE)
       {
+         // no-op
       }
       else if (id == Keyboard.SE_END_ROW_RESIZE)
       {
@@ -1701,7 +1701,6 @@
                break;
             }
 
-            BrowseColumnConfig c = column.config();
             int newWidth = (int) (availableWidth * ((double) dataWidth / totalDataWidth));
             column.setWidth(Math.max(cc.widthFromNative(newWidth), minWidth));
             totalWidth += column.physicalDimension().width;
@@ -1737,7 +1736,7 @@
             {
                BrowseColumnGuiImpl column = getColumn(i);
                column.config().selectable = brc.selectable;
-               ((GuiDriver) screen().getDriver()).registerDirectManipulation(column);
+               ((GuiDriver) OutputManager.getDriver()).registerDirectManipulation(column);
             }
          }
       }
@@ -1806,10 +1805,8 @@
       {
          return -1;
       }
-      else
-      {
-         return y / (getRowHeight() + BORDER_THICKNESS);
-      }
+      
+      return y / (getRowHeight() + BORDER_THICKNESS);
    }
 
    /**
@@ -2643,17 +2640,13 @@
          {
             return gd.getSysColor(SysColor.COLOR_3DFACE);
          }
-         else
-         {
-            GuiColorResolver browseResolver = getBrowseColorResolver();
-            return fg ? browseResolver.fgColor : browseResolver.bgColor;
-         }
-      }
-      else
-      {
-         return fg ? ColorManager.getFgColor(window, color) :
-               ColorManager.getBgColor(window, color);
-      }
+         
+         GuiColorResolver browseResolver = getBrowseColorResolver();
+         return fg ? browseResolver.fgColor : browseResolver.bgColor;
+      }
+      
+      return fg ? ColorManager.getFgColor(window, color) :
+            ColorManager.getBgColor(window, color);
    }
 
    /**
@@ -2688,6 +2681,7 @@
    {
       draggedColumn = column;
       this.leftDragColumnMouseOffset = leftDragColumnMouseOffset;
+      MouseHandler.startDragMode();
    }
 
    /**
@@ -2766,6 +2760,7 @@
                               (visibleColumnIndex < config.numLockedColumns ? 0 :
                                  resizedColumn.parent().physicalLocation().x);
       leftResizeColumnOffset = Math.max(columnLeftEdge, browseLeftEdge);
+      MouseHandler.startDragMode();
    }
 
    /**
@@ -2959,10 +2954,8 @@
       {
          return FontManager.resolveFont(window(), labelFont, gd);
       }
-      else
-      {
-         return getBrowseFont();
-      }
+      
+      return getBrowseFont();
    }
 
    /**
@@ -3380,8 +3373,8 @@
                FillIn fillIn = (FillIn) editor;
                if (mouseFocusGained)
                {
-                  fillIn.config().selectionStart = FillInConfig.INVALID_SELECTION;
-                  fillIn.config().selectionEnd = FillInConfig.INVALID_SELECTION;
+                  fillIn.config().selectionStart = ControlConfig.INVALID_SELECTION;
+                  fillIn.config().selectionEnd = ControlConfig.INVALID_SELECTION;
                   fillIn.setCursorOffset(0);
                   fillIn.setZapMode(false);
                }
@@ -3821,31 +3814,6 @@
    }
 
    /**
-    * Checks if the browse scrollbar with the given orientation is visible.
-    *
-    * @param orientation
-    *        Scrollbar orientation: vertical or horizontal.
-    *
-    * @return <code>true</code> the browse scrollbar with the given orientation is visible.
-    */
-   private boolean isScrollBarVisible(ScrollBar.Orientation orientation)
-   {
-      ScrollBarGuiImpl bar;
-      boolean visible = false;
-
-      if (scrollPane != null)
-      {
-         bar = scrollPane.getScrollBar(orientation);
-         if (bar != null)
-         {
-            visible = bar.isVisible();
-         }
-      }
-
-      return visible;
-   }
-
-   /**
     * This functions contains the common code for showing/hiding the line of the column filter
     * entry fields.
     */
@@ -4613,10 +4581,8 @@
       {
          return calcImplicitRowHeight();
       }
-      else
-      {
-         return calcExplicitRowHeight();
-      }
+      
+      return calcExplicitRowHeight();
    }
 
    /**
@@ -4971,10 +4937,10 @@
     *
     * @return <code>true</code> if CTRL key was held down when a mouse button was pressed.
     */
-   boolean isCtrlModifier(MouseEvent e)
+   static boolean isCtrlModifier(MouseEvent e)
    {
-      return (e.getModifiers()   & MouseEvent.CTRL_MASK)      != 0 ||
-             (e.getModifiersEx() & MouseEvent.CTRL_DOWN_MASK) != 0;
+      return (e.getModifiers()   & InputEvent.CTRL_MASK)      != 0 ||
+             (e.getModifiersEx() & InputEvent.CTRL_DOWN_MASK) != 0;
    }
    
    /**
@@ -5385,10 +5351,10 @@
     *
     * @return <code>true</code> if SHIFT key was held down when a mouse button was pressed.
     */
-   private boolean isShiftModifier(MouseEvent e)
+   private static boolean isShiftModifier(MouseEvent e)
    {
-      return (e.getModifiers()   & MouseEvent.SHIFT_MASK)      != 0 ||
-             (e.getModifiersEx() & MouseEvent.SHIFT_DOWN_MASK) != 0;
+      return (e.getModifiers()   & InputEvent.SHIFT_MASK)      != 0 ||
+             (e.getModifiersEx() & InputEvent.SHIFT_DOWN_MASK) != 0;
    }
 
    /**
@@ -6366,7 +6332,7 @@
     * @param destIndex
     *        0-based position to which the element is moved.
     */
-   private void moveColumnInArray(Object[] array, int srcIndex, int destIndex)
+   private static void moveColumnInArray(Object[] array, int srcIndex, int destIndex)
    {
       if (array == null)
       {
@@ -6638,6 +6604,7 @@
       }
       else if (isEditorToggleBox())
       {
+         // no-op
       }
       else
       {
@@ -6808,7 +6775,6 @@
     */
    private class HorizontalColumnScroller
    extends ScrollBarControllerGuiImpl
-   implements ScrollBarController
    {
       /**
        * Get maximum value for the scroll bar.
@@ -6881,10 +6847,8 @@
 
             return 0;
          }
-         else
-         {
-            return offset;
-         }
+         
+         return offset;
       }
 
       /**
@@ -6919,7 +6883,7 @@
 
          int availSize = scrollBar.getTravelSize() - getThumbSize();
          int tPos = Coordinate.toInt(Coordinate.scale(
-               (double) availSize * (double) getPosition() / (double) getMax()));
+               (double) availSize * (double) getPosition() / getMax()));
          tPos = Math.max(0, tPos);
          tPos = Math.min(tPos, availSize);
          return tPos;
@@ -7040,7 +7004,7 @@
 
             int position = availSize > 0 ?
                               Coordinate.toInt(Coordinate.scale(
-                                    (double) dragPos * (double) getMax() / (double) availSize)) :
+                                    (double) dragPos * (double) getMax() / availSize)) :
                               0;
 
             positionUpdated(position, ScrollStep.CUSTOM, true);
@@ -7148,24 +7112,22 @@
             {
                return;
             }
-            else
+            
+            int pageSize = getPageSize();
+            if (ScrollStep.LONG.equals(scrollStep))
             {
-               int pageSize = getPageSize();
-               if (ScrollStep.LONG.equals(scrollStep))
-               {
-                  if (position < oldPosition)
-                  {
-                     position = oldPosition - pageSize;
-                  }
-                  else
-                  {
-                     position = oldPosition + pageSize;
-                  }
-               }
+               if (position < oldPosition)
+               {
+                  position = oldPosition - pageSize;
+               }
+               else
+               {
+                  position = oldPosition + pageSize;
+               }
+            }
 
-               position += pageSize;
-               scrollToRow(position, false, false, drag, true, true, pageSize, false);
-            }
+            position += pageSize;
+            scrollToRow(position, false, false, drag, true, true, pageSize, false);
          }
          else
          {
@@ -7246,10 +7208,8 @@
             int firstExistingRow = getFirstExistingRow();
             return firstExistingRow == -1 ? 0 : firstExistingRow;
          }
-         else
-         {
-            return Math.max(0, config.maxDataGuess - getDown());
-         }
+         
+         return Math.max(0, config.maxDataGuess - getDown());
       }
 
       /**
@@ -7300,7 +7260,7 @@
             int scrollSize = getAvailableTravelSize() - getThumbSize();
             int maxVal = getMax();
             int position = Coordinate.toInt(Coordinate.scale(
-                              (double)dragPos * (double)maxVal / (double)scrollSize));
+                              (double)dragPos * (double)maxVal / scrollSize));
             position = Math.max(0, position);
             position = Math.min(position, maxVal);
 
@@ -7336,12 +7296,12 @@
             {
                lastExistingRow += 1; // 1-based row number
                dHeight = (double) availSize *
-                     (double) lastExistingRow / (double) (lastExistingRow + 1);
+                     (double) lastExistingRow / (lastExistingRow + 1);
             }
          }
          else
          {
-            dHeight = (double) availSize * (double) getDown() / (double) config.maxDataGuess;
+            dHeight = (double) availSize * (double) getDown() / config.maxDataGuess;
          }
          int tHeight = Coordinate.toInt(Coordinate.scale(dHeight));
 
@@ -7376,7 +7336,7 @@
          {
             pos = Coordinate.toInt(Coordinate.scale(
                   (double) availSize * (double) getPosition() /
-                        (double) (config.maxDataGuess - getDown())));
+                        (config.maxDataGuess - getDown())));
             pos = Math.min(pos, availSize);
          }
 

=== modified file 'src/com/goldencode/p2j/ui/client/gui/ButtonListGuiImpl.java'
--- src/com/goldencode/p2j/ui/client/gui/ButtonListGuiImpl.java	2021-07-26 22:23:19 +0000
+++ src/com/goldencode/p2j/ui/client/gui/ButtonListGuiImpl.java	2022-03-08 22:06:23 +0000
@@ -2,7 +2,7 @@
 ** Module   : ButtonListGuiImpl.java
 ** Abstract : ButtonListGuiImpl implements the button list widget.
 **
-** Copyright (c) 2020-2021, Golden Code Development Corporation.
+** Copyright (c) 2020-2022, Golden Code Development Corporation.
 **
 ** -#- -I- --Date-- --------------------------------Description-----------------------------------
 ** 001 SBI 20200305 Created initial version.
@@ -18,6 +18,10 @@
 **     SBI 20210617 Changed to display its first button with expanded items list and fixed its accordion-like style.
 **     RFB 20210726 Protect afterConfigUpdate from indexing into the GroupButtons when it is invalid. 
 **                  Ref #5562.
+**     VVT 20220306 processKeyEvent: piece of code doing nothing removed.
+**                  findMouseSource(NativePoint) fixed.
+**                  findMouseSource(eventId, NativePoint) was overriden. See #6013.
+**                  setSelected: missing Javadocs added.
 */
 
 /*
@@ -841,20 +845,6 @@
             return;
          }
          
-         
-         if (key == Keyboard.KA_CURSOR_LEFT)
-         {
-         }
-         else if (key == Keyboard.KA_CURSOR_RIGHT)
-         {
-         }
-         else if (key == Keyboard.KA_CURSOR_UP || key == Keyboard.KA_CURSOR_DOWN)
-         {
-         }
-         else if (key == Keyboard.KA_RETURN)
-         {
-         }
-         
          repaint();
       }
    }
@@ -1380,10 +1370,10 @@
       private Viewport<GuiOutputManager> itemsView;
       
       /** The scroll up button */
-      private ButtonGuiImpl scrollUpButton;
+      private final ButtonGuiImpl scrollUpButton;
       
       /** The scroll down button */
-      private ButtonGuiImpl scrollDownButton;
+      private final ButtonGuiImpl scrollDownButton;
       
       /** 
        * Creates the items control for the given items list.
@@ -1474,6 +1464,7 @@
       /**
        * Prepares its components.
        */
+      @Override
       public void doLayout()
       {
          changeControlState();
@@ -1581,46 +1572,75 @@
        * 
        * @return   The item under the mouse pointer.
        */
+      @Override
       public Widget<GuiOutputManager> findMouseSource(NativePoint p)
       {
          Widget<GuiOutputManager> w = super.findMouseSource(p);
-         
-         if (w == scrollDownButton || w == scrollUpButton || w instanceof Item)
-         {
-            return w;
-         }
-         
-         if (w == null)
-         {
-            //adjust x-coordinate
-            NativeRectangle nd = this.itemsView.physicalBounds();
-            
-            int x = p.x;
-            
-            int y = p.y;
-            
-            if (nd.left() > x)
-            {
-               x = nd.left() + 1;
-            }
-            
-            if (nd.right() < x)
-            {
-               x = nd.right() - 1;
-            }
-            
-            w = super.findMouseSource(new NativePoint(x, y));
-            
-            if (w == scrollDownButton || w == scrollUpButton || w instanceof Item)
-            {
-               return w;
-            }
-         }
-         
-         return w;
+         if (w != null)
+         {
+            return w;
+         }
+
+         //adjust x-coordinate
+         NativeRectangle nd = this.itemsView.physicalBounds();
+
+         int x = p.x;
+
+         int y = p.y;
+
+         if (nd.left() > x)
+         {
+            x = nd.left() + 1;
+         }
+
+         if (nd.right() < x)
+         {
+            x = nd.right() - 1;
+         }
+
+         return super.findMouseSource(new NativePoint(x, y));
+      }
+
+      /**
+       * Find the source for mouse event.
+       * 
+       * @param eventId
+       *        the event ID to match 
+       * @param p
+       *        the mouse position relative to this widget
+       *        
+       * @return the mouse event source or {@code null} if no source found.
+       */
+      @Override
+      public Widget<GuiOutputManager> findMouseSource(int eventId, NativePoint p)
+      {
+         Widget<GuiOutputManager> w = super.findMouseSource(eventId, p);
+         if (w != null)
+         {
+            return w;
+         }
+
+         //adjust x-coordinate
+         NativeRectangle nd = this.itemsView.physicalBounds();
+
+         int x = p.x;
+
+         int y = p.y;
+
+         if (nd.left() > x)
+         {
+            x = nd.left() + 1;
+         }
+
+         if (nd.right() < x)
+         {
+            x = nd.right() - 1;
+         }
+
+         return super.findMouseSource(eventId, new NativePoint(x, y));
       }
    }
-   
+
    /**
     * Represents a scrollable items list.
     */
@@ -2042,6 +2062,7 @@
        * 
        * @return   The item under the mouse pointer.
        */
+      @Override
       public Widget<GuiOutputManager> findMouseSource(NativePoint p)
       {
          NativePoint shift = new NativePoint(0, itemIndexOffset * itemHeightInPixels);
@@ -2073,6 +2094,49 @@
          
          return super.findMouseSource(p);
       }
+
+      /**
+       * Find the source for mouse event.
+       * 
+       * @param eventId
+       *        the event ID to match 
+       * @param p
+       *        the mouse position relative to this widget
+       *        
+       * @return the mouse event source or {@code null} if no source found.
+       */
+      @Override
+      public Widget<GuiOutputManager> findMouseSource(int eventId, NativePoint p)
+      {
+         NativePoint shift = new NativePoint(0, itemIndexOffset * itemHeightInPixels);
+         
+         NativePoint loc = p.minus(shift);
+         
+         NativeDimension size = getVisibleDimension();
+         
+         if (loc.x >= 0 && loc.x < size.width && loc.y >= 0 && loc.y <= size.height)
+         {
+            for (int i = 0, h = 0; i < numberOfVisibleItems; i++, h += itemHeightInPixels)
+            {
+               if (h <= loc.y && loc.y <= (h + itemHeightInPixels))
+               {
+                  return get(itemIndexOffset + i);
+               }
+            }
+            
+            int limitIndex = itemIndexOffset + numberOfVisibleItems;
+            
+            // calculate the index of a partly visible or the last item
+            if (limitIndex == numberOfAllItems)
+            {
+               limitIndex--;
+            }
+            
+            return get(limitIndex);
+         }
+         
+         return super.findMouseSource(eventId, p);
+      }
    }
    
    /**
@@ -2135,6 +2199,7 @@
        * 
        * @return   The item's dimension
        */
+      @Override
       public Dimension dimension()
       {
          return new Dimension(this.config.widthChars, this.config.heightChars);
@@ -2145,6 +2210,7 @@
        * 
        * @return   The item's width
        */
+      @Override
       public double width()
       {
          return dimension().width;
@@ -2155,6 +2221,7 @@
        * 
        * @return   The item's height
        */
+      @Override
       public double height()
       {
          return dimension().height;
@@ -2205,6 +2272,12 @@
          doLayout();
       }
       
+      /**
+       * Select or deselect this item.
+       * 
+       * @param isSelected
+       *        new selection status
+       */
       public void setSelected(boolean isSelected)
       {
          config.selected = isSelected;
@@ -2271,6 +2344,7 @@
                 * @param    e
                 *           The mouse event.
                 */
+               @Override
                public void mouseClicked(MouseEvent e)
                {
                   ButtonListGuiImpl.this.mouseClicked(e);
@@ -2500,9 +2574,26 @@
        * 
        * @return   The item under the mouse pointer.
        */
+      @Override
       public Widget<GuiOutputManager> findMouseSource(NativePoint p)
       {
          return this;
       }
+
+      /**
+       * Find the source for mouse event.
+       * 
+       * @param eventId
+       *        the event ID to match 
+       * @param p
+       *        the mouse position relative to this widget
+       *        
+       * @return the mouse event source or {@code null} if no source found.
+       */
+      @Override
+      public Widget<GuiOutputManager> findMouseSource(int eventId, NativePoint p)
+      {
+         return this;
+      }
    }
 }

=== modified file 'src/com/goldencode/p2j/ui/client/gui/CaptionButton.java'
--- src/com/goldencode/p2j/ui/client/gui/CaptionButton.java	2019-09-08 09:25:29 +0000
+++ src/com/goldencode/p2j/ui/client/gui/CaptionButton.java	2022-03-06 21:49:25 +0000
@@ -2,7 +2,7 @@
 ** Module   : CaptionButton.java
 ** Abstract : Define caption button associated with a window.
 **
-** Copyright (c) 2014-2017, Golden Code Development Corporation.
+** Copyright (c) 2014-2022, Golden Code Development Corporation.
 **
 ** -#- -I- --Date-- ---------------------------------Description----------------------------------
 ** 001 CA  20140805 Created initial version.
@@ -33,6 +33,7 @@
 ** 019 OM  20170407 Fixed list of handled mouseActions.
 ** 020 HC  20170823 Removed unused code of the window-state runtime logic.
 ** 021 SBI 20190908 Changed to send the window close command directly to the OS queue.
+** 022 VVT 20220306 mouseActions: MouseEvent.MOUSE_MOVED was added to the list of actions. See #6013.
 */
 /*
 ** This program is free software: you can redistribute it and/or modify
@@ -308,6 +309,7 @@
          MouseEvent.MOUSE_ENTERED,
          MouseEvent.MOUSE_EXITED,
          MouseEvent.MOUSE_DRAGGED,
+         MouseEvent.MOUSE_MOVED
       };
 
       return res;

=== modified file 'src/com/goldencode/p2j/ui/client/gui/EditorGuiImpl.java'
--- src/com/goldencode/p2j/ui/client/gui/EditorGuiImpl.java	2021-12-06 15:35:23 +0000
+++ src/com/goldencode/p2j/ui/client/gui/EditorGuiImpl.java	2022-03-06 21:49:25 +0000
@@ -2,7 +2,7 @@
 ** Module   : EditorGuiImpl.java
 ** Abstract : EDITOR widget implementation. GUI-specific version.
 **
-** Copyright (c) 2015-2021, Golden Code Development Corporation.
+** Copyright (c) 2015-2022, Golden Code Development Corporation.
 **
 ** -#- -I- --Date-- ----------------------------------------Description---------------------------------------
 ** 001 CA  20150509 Created initial version.
@@ -100,6 +100,7 @@
 **     CA  20211206 isPrintableKey() must know if the key is real or not, as its code can be used only when 
 **                  the key is originating from a real key press; otherwise, its label must be checked, as the 
 **                  key code may be for a legacy event name, which can collide with a real UTF-8 key code.
+**     VVT 20220306 findMouseSource(eventId, NativePoint) was overriden. See #6013.
 */
 
 /*
@@ -1811,6 +1812,24 @@
    }
 
    /**
+    * Find the source for mouse event.
+    * 
+    * @param eventId
+    *        the event ID to match 
+    * @param p
+    *        the mouse position relative to this widget
+    *        
+    * @return the mouse event source or {@code null} if no source found.
+    */
+   @Override
+   public Widget<GuiOutputManager> findMouseSource(int eventId, NativePoint p)
+   {
+      Widget<GuiOutputManager> src = super.findMouseSource(eventId, p);
+      
+      return (src == editor || src == contentPane) ? this : src;
+   }
+
+   /**
     * Get the widget's actual bounds
     * 
     * @return widget's actual bounds

=== modified file 'src/com/goldencode/p2j/ui/client/gui/FrameGuiImpl.java'
--- src/com/goldencode/p2j/ui/client/gui/FrameGuiImpl.java	2022-02-18 17:35:06 +0000
+++ src/com/goldencode/p2j/ui/client/gui/FrameGuiImpl.java	2022-03-06 21:49:25 +0000
@@ -2,7 +2,7 @@
 ** Module   : FrameGuiImpl.java
 ** Abstract : Frame implementation for GUI
 **
-** Copyright (c) 2014-2021, Golden Code Development Corporation.
+** Copyright (c) 2014-2022, Golden Code Development Corporation.
 **
 ** -#- -I- --Date-- ---------------------------------Description---------------------------------
 ** 001 MAG 20141010 Created initial version.
@@ -157,6 +157,7 @@
 **     EVL 20220112 Fix for missed mouse drag event in web client.
 **     AL2 20220127 Register all realized frames as empty selectors: can deselect all widgets from a window.
 **     VVT 20220218 Javadocs and other cosmetic fixes.
+**     VVT 20220306 findMouseSource(eventId, NativePoint) was overriden. See #6013.
 */
 
 /*
@@ -1107,6 +1108,37 @@
       return foundWidget;
    }
 
+   @Override
+   public Widget<GuiOutputManager> findMouseSource(int eventId, NativePoint p)
+   {
+      // the point incoming is related to frame origin, we need to substract the frame title
+      NativePoint pCheck = hasTitle() ? p.minus(frameScroll.physicalLocation()) : p;
+      
+      Widget<GuiOutputManager> foundWidget = frameScroll.findMouseSource(eventId, pCheck);
+      
+      if (foundWidget == null)
+      {
+         foundWidget = (this.physicalBounds().contains(p) ? this : null);
+      }
+      
+      // if the widget is a label, the "source" will be the frame scroll in order to prevent
+      // exit and enter mouse events for the frame if the mouse pointer is over the label.
+      if (foundWidget instanceof LabelGuiImpl)
+      {
+         return frameScroll;
+      }
+      
+      // if the widget is not enabled, then the source is the frame, too
+      if (foundWidget != null                              &&
+          foundWidget.config() != null                     &&
+          !WidgetId.virtualWidget(foundWidget.config().id) &&
+          !foundWidget.isEnabled()) // TODO: tooltips work with disabled widgets
+      {
+         return this;
+      }
+      
+      return foundWidget;
+   }
    /**
     * Get a point to represent the LAST-EVENT:X and LAST-EVENT:Y coordinates.  For frames, these
     * represents a point relative to the frame's top-left corner (excluding title).

=== modified file 'src/com/goldencode/p2j/ui/client/gui/ModalWindow.java'
--- src/com/goldencode/p2j/ui/client/gui/ModalWindow.java	2022-02-15 12:19:45 +0000
+++ src/com/goldencode/p2j/ui/client/gui/ModalWindow.java	2022-03-09 17:35:49 +0000
@@ -74,6 +74,7 @@
 **                  method added. See #6013.
 **     VVT 20220215 Change 13474 for #6013 temporary reverted (caused multiple regressions,
 **                  need to be completed).
+**     VVT 20220306 findMouseSource(eventId, NativePoint) was overriden. See #6013.
 */
 /*
 ** This program is free software: you can redistribute it and/or modify
@@ -165,9 +166,6 @@
    /** Cached GUI driver reference. */  
    protected GuiDriver<?,?> gd;
 
-   /** The last mouse pressed determined for this window. */
-   private Widget<GuiOutputManager> mousePressedSource = null;
-   
    /** Destroy flag. */
    protected boolean destroyInProgress;
    
@@ -640,7 +638,7 @@
    }
    
    /**
-    * Get the title bar widget associated witn this window.
+    * Get the title bar widget associated with this window.
     * 
     * @return   See above.
     */
@@ -747,50 +745,35 @@
    }
    
    /**
-    * Find the widget to which the given mouse event can be applied.
-    * 
-    * @param    evt
-    *           The mouse event.
-    * 
-    * @return   A widget over which the mouse is positioned or {@code null} if none found.
-    */
-   @Override
-   public Widget<GuiOutputManager> findMouseSource(MouseEvt evt)
-   {
-      Widget<GuiOutputManager> widget = null;
-      
-      int evtID = evt.getEvent().getID();
-      
-      if (evtID == MouseEvent.MOUSE_DRAGGED  || 
-          evtID == MouseEvent.MOUSE_RELEASED ||
-          evtID == MouseEvent.MOUSE_CLICKED)
-      {
-         return mousePressedSource;
-      }
-      
-      try
-      {
-         java.awt.Point p = evt.getEvent().getPoint();
-         
-         // search the other widgets
-         widget = windowPane.findMouseSource(new NativePoint(p.x, p.y));
-         
-         widget = (widget == null ? this : widget);
-      }
-      finally
-      {
-         if (widget != null && evtID == MouseEvent.MOUSE_PRESSED)
-         {
-            mousePressedSource = widget;
-         }
-         
-         if (evtID == MouseEvent.MOUSE_CLICKED)
-         {
-            mousePressedSource = null;
-         }
-      }
-      
-      return widget;
+    * Find the source for mouse event.
+    * 
+    * @param eventId
+    *        the event ID to match 
+    * @param p
+    *        the mouse position relative to this widget
+    *        
+    * @return the mouse event source or {@code null} if no source found.
+    */
+   @Override
+   public Widget<GuiOutputManager> findMouseSource(int eventId, NativePoint p)
+   {
+      return windowPane.findMouseSource(eventId, p);
+   }
+
+   /**
+    * Find the widget positioned just bellow the specified mouse position (in physical units).
+    * Each container should search for own widgets. Because widgets are relative positioned 
+    * inside containers the container physical position is adjusted before search.  
+    * 
+    * @param    p
+    *           The mouse physical location.
+    * 
+    * @return   A widget over which the mouse is positioned or <code>null</code> if none found.
+    */
+   @Override
+   public Widget<GuiOutputManager> findMouseSource(NativePoint p)
+   {
+      return windowPane.findMouseSource(p);
    }
 
    /**

=== modified file 'src/com/goldencode/p2j/ui/client/gui/OverlayWindow.java'
--- src/com/goldencode/p2j/ui/client/gui/OverlayWindow.java	2022-02-15 12:19:45 +0000
+++ src/com/goldencode/p2j/ui/client/gui/OverlayWindow.java	2022-03-09 22:24:45 +0000
@@ -542,48 +542,6 @@
    }
    
    /**
-    * Find the widget to which the given mouse event can be applied.
-    * 
-    * @param    evt
-    *           The mouse event.
-    * 
-    * @return   A widget over which the mouse is positioned or {@code null} if none found.
-    */
-   @Override
-   public Widget<GuiOutputManager> findMouseSource(MouseEvt evt)
-   {
-      Widget<GuiOutputManager> widget = null;
-      
-      int evtID = evt.getEvent().getID();
-      
-      if (evtID == MouseEvent.MOUSE_DRAGGED  || 
-          evtID == MouseEvent.MOUSE_RELEASED ||
-          evtID == MouseEvent.MOUSE_CLICKED)
-      {
-         return mousePressedSource;
-      }
-      
-      try
-      {
-         java.awt.Point p = evt.getEvent().getPoint();
-         
-         // search the other widgets
-         widget = findMouseSource(new NativePoint(p.x, p.y));
-         
-         widget = (widget == null ? this : widget);
-      }
-      finally
-      {
-         if (widget != null && evtID == MouseEvent.MOUSE_PRESSED)
-         {
-            mousePressedSource = widget;
-         }
-      }
-      
-      return widget;
-   }
-
-   /**
     * Get a point to represent the LAST-EVENT:X and LAST-EVENT:Y coordinates.  For overlay windows,
     * these returns always <code>null</code>.
     * 

=== modified file 'src/com/goldencode/p2j/ui/client/gui/TreeListCaptionItem.java'
--- src/com/goldencode/p2j/ui/client/gui/TreeListCaptionItem.java	2021-07-13 20:19:47 +0000
+++ src/com/goldencode/p2j/ui/client/gui/TreeListCaptionItem.java	2022-03-10 16:03:19 +0000
@@ -299,6 +299,9 @@
                return;
             }
 
+            // Start drag mode            
+            MouseHandler.startDragMode();
+            
             final TreeListCaptionItem ci = new TreeListCaptionItem(tree,
                      new TreeListGuiImpl.ColumnCache(column));
 
@@ -409,6 +412,7 @@
          {
             gd.setCursor(MousePtrWrapper.E_RESIZE);
             atResizeEdge = true;
+            MouseHandler.startDragMode();
          }
          else
          {

